/*	Sample program for Olimex AVR-MT-128 with ATMega128 processor
 *	Press Button 1 to set the Led On
 *	Hold Button 2 to start blink the Led
 *	Press Button 3 to toggle the Led
 *	Hold Button 4 to activate the Buzzer
 *	Press Button 5 to set the Led Off
 *	Compile with AVRStudio+WinAVR (gcc version 3.4.6)
 */

#include "avr/io.h"

#define	__AVR_ATMEGA128__	1
#define Frequency			1000

void Initialize()
{
	PORTA = 0b00000000;		DDRA = 0b01000000;	//Relay set as output (Bit 6 = 1)
	PORTB = 0b00000000;		DDRB = 0b00000000;
	PORTC = 0b00000000;		DDRC = 0b00000000;
	PORTD = 0b00000000;		DDRD = 0b00000000;
	PORTE = 0b00000000;		DDRE = 0b00110000;	//Buzzer's PORTS set as output (Bit4 = 1, Bit5 = 1)
	PORTF = 0b00000000;		DDRF = 0b00000000;
	PORTG = 0b00000000;		DDRG = 0b00000000;

	
}

int main()
{
	Initialize();
	int i, j, Bl=1;
	while(1)
	{
		if (!(PINA & 0b00000001))	PORTA = PORTA | 0b01000000;

		while (!(PINA & 0b00000010))
		{
			//check state of Button 2 before each opearator
			if (!(PINA & 0b00000010))	PORTA = PORTA & 0b10111111;
			if (!(PINA & 0b00000010))	for (i=10; i; i--)
			if (!(PINA & 0b00000010))	for (j=30000; j; j--);
			if (!(PINA & 0b00000010))	PORTA = PORTA | 0b01000000;
			if (!(PINA & 0b00000010))	for (i=10; i; i--)
			if (!(PINA & 0b00000010))	for (j=30000; j; j--);
		}

		if ((!(PINA & 0b00000100)) & Bl)
			{
			if (PINA & 0b01000000)
				PORTA = PORTA & 0b10111111;
			else
				PORTA = PORTA | 0b01000000;
			//Bl prevents holding of Button 3
			Bl = 0;
			}
		
		while (!(PINA & 0b00001000))
		{
			PORTE = (PORTE & 0b11011111) | 0b00010000;	//switching states of Bits4 and Bit5 (activating the Buzzer)
			for (i=Frequency; i; i--);					//Delay
			PORTE = (PORTE | 0b00100000) & 0b11101111;	//switching states of Bits4 and Bit5 (activating the Buzzer)
			for (i=Frequency; i; i--);					//Delay
		}

		if (!(PINA & 0b00010000))	PORTA = PORTA = PORTA & 0b10111111;

		//chech state of Button 3 (if it isn't pressed next time will affect)
		if (PINA & 0b00000100)
			Bl = 1;
	}
	return 0;
}
